// TsDescriptor.cpp: fXNv^NX
//
/////////////////////////////////////////////////////////////////////////////

#include "StdAfx.h"
#include "BonSDK.h"
#include "TsDescriptor.h"
#include <TChar.h>


/////////////////////////////////////////////////////////////////////////////
// ̎NX͋Lqq̃f[^ێAIDescBlockC^tF[X
// NXێ郁ubNQƂB
// ̂߂̃NXIDescBlockC^tF[X擾ĎgpȂ
// ȂȂB(PƂŃCX^X𐶐邱Ƃ͂łȂ)
/////////////////////////////////////////////////////////////////////////////


/////////////////////////////////////////////////////////////////////////////
// [0x09] Conditional Access Method LqqNX
/////////////////////////////////////////////////////////////////////////////

const WORD CCaMethodDesc::GetCaMethodID(void) const
{
	// MIDԂ
	return (WORD)m_pDescData[0] << 8 | (WORD)m_pDescData[1];
}

const WORD CCaMethodDesc::GetCaPID(void) const
{
	// MPIDԂ
	return (WORD)(m_pDescData[2] & 0x1FU) << 8 | (WORD)m_pDescData[3];
}

const BYTE * CCaMethodDesc::GetPrivateData(void) const
{
	// vCx[gf[^Ԃ
	return &m_pDescData[4];
}

const BYTE CCaMethodDesc::GetPrivateDataSize(void) const
{
	// vCx[gf[^Ԃ
	return m_byDescLen - 4U;
}

CCaMethodDesc::CCaMethodDesc(IBonObject *pOwner)
	: CDescBase(pOwner)
{
	// Ȃ
}

CCaMethodDesc::~CCaMethodDesc(void)
{
	// Ȃ
}

const bool CCaMethodDesc::ParseData(void)
{
	// TCŶ݃`FbN
	return (m_byDescLen >= 4U)? true : false;
}


/////////////////////////////////////////////////////////////////////////////
// [0x40] lbg[N LqqC^tF[X
/////////////////////////////////////////////////////////////////////////////

const DWORD CNetworkNameDesc::GetNetworkName(LPTSTR lpszDst) const
{
	// lbg[N`FbN
	if(!m_byDescLen)return 0UL;

	// lbg[N擾
	TCHAR szName[256] = TEXT("\0");
	CAribString::AribToString(szName, &m_pDescData[0], m_byDescLen);

	// obt@ɃRs[
	if(lpszDst)::_tcscpy(lpszDst, szName);

	// obt@ɕKvȕԂ
	return ::_tcslen(szName);
}

CNetworkNameDesc::CNetworkNameDesc(IBonObject *pOwner)
	: CDescBase(pOwner)
{
	// Ȃ
}

CNetworkNameDesc::~CNetworkNameDesc(void)
{
	// Ȃ
}

const bool CNetworkNameDesc::ParseData(void)
{
	// TCŶ݃`FbN
	return (m_byDescLen >= 1U)? true : false;
}


/////////////////////////////////////////////////////////////////////////////
// [0x41] T[rXXg LqqC^tF[X
/////////////////////////////////////////////////////////////////////////////

const DWORD CServiceListDesc::GetServiceNum(void) const
{
	// T[rXԂ
	return m_byDescLen / 3UL;
}

const WORD CServiceListDesc::GetServiceID(const DWORD dwIndex) const
{
	// T[rXIDԂ
	return (dwIndex < GetServiceNum())? ((WORD)m_pDescData[dwIndex * 3] << 8 | (WORD)m_pDescData[dwIndex * 3 + 1]) : 0x0000U;
}

const BYTE CServiceListDesc::GetServiceType(const DWORD dwIndex) const
{
	// T[rX`ʂԂ
	return (dwIndex < GetServiceNum())? m_pDescData[dwIndex * 3 + 2] : 0x00U;
}

CServiceListDesc::CServiceListDesc(IBonObject *pOwner)
	: CDescBase(pOwner)
{
	// Ȃ
}

CServiceListDesc::~CServiceListDesc(void)
{
	// Ȃ
}

const bool CServiceListDesc::ParseData(void)
{
	// TCŶ݃`FbN
	return (!m_byDescLen || (m_byDescLen % 3U))? true : false;
}


/////////////////////////////////////////////////////////////////////////////
// [0x48] Service LqqNX
/////////////////////////////////////////////////////////////////////////////

const BYTE CServiceDesc::GetServiceType(void) const
{
	// T[rX`IDԂ
	return m_pDescData[0];
}

const DWORD CServiceDesc::GetProviderName(LPTSTR lpszDst) const
{
	// ƎҖ`FbN
	const DWORD dwPos = 1UL;
	if(!m_pDescData[dwPos])return 0UL;

	// ƎҖ擾
	TCHAR szName[256] = TEXT("\0");
	CAribString::AribToString(szName, &m_pDescData[dwPos + 1UL], m_pDescData[dwPos]);

	// obt@ɃRs[
	if(lpszDst)::_tcscpy(lpszDst, szName);

	// obt@ɕKvȕԂ
	return ::_tcslen(szName);
}

const DWORD CServiceDesc::GetServiceName(LPTSTR lpszDst) const
{
	// T[rX`FbN
	const DWORD dwPos = (DWORD)m_pDescData[1] + 2UL;
	if(!m_pDescData[dwPos])return 0UL;

	// T[rX擾
	TCHAR szName[256] = TEXT("\0");
	CAribString::AribToString(szName, &m_pDescData[dwPos + 1UL], m_pDescData[dwPos]);

	// obt@ɃRs[
	if(lpszDst)::_tcscpy(lpszDst, szName);

	// obt@ɕKvȕԂ
	return ::_tcslen(szName);
}

CServiceDesc::CServiceDesc(IBonObject *pOwner)
	: CDescBase(pOwner)
{
	// Ȃ
}

CServiceDesc::~CServiceDesc(void)
{
	// Ȃ
}

const bool CServiceDesc::ParseData(void)
{
	// TCŶ݃`FbN
	return (m_byDescLen >= 3U)? true : false;
}


/////////////////////////////////////////////////////////////////////////////
// [0x4D] Short Event LqqNX
/////////////////////////////////////////////////////////////////////////////

const DWORD CShortEventDesc::GetLanguageCode(void) const
{
	// R[hԂ
	return ((DWORD)m_pDescData[0] << 16) | ((DWORD)m_pDescData[1] << 8) | (DWORD)m_pDescData[2];
}

const DWORD CShortEventDesc::GetEventName(LPTSTR lpszDst) const
{
	// ԑg`FbN
	const DWORD dwPos = 3UL;
	if(!m_pDescData[dwPos])return 0UL;

	// ԑg擾
	TCHAR szName[256] = TEXT("\0");
	CAribString::AribToString(szName, &m_pDescData[dwPos + 1UL], m_pDescData[dwPos]);

	// obt@ɃRs[
	if(lpszDst)::_tcscpy(lpszDst, szName);

	// obt@ɕKvȕԂ
	return ::_tcslen(szName);
}

const DWORD CShortEventDesc::GetEventDesc(LPTSTR lpszDst) const
{
	// ԑgLq`FbN
	const DWORD dwPos = (DWORD)m_pDescData[3] + 4UL;
	if(!m_pDescData[dwPos])return 0UL;

	// ԑgLq擾
	TCHAR szName[256] = TEXT("\0");
	CAribString::AribToString(szName, &m_pDescData[dwPos + 1UL], m_pDescData[dwPos]);

	// obt@ɃRs[
	if(lpszDst)::_tcscpy(lpszDst, szName);

	// obt@ɕKvȕԂ
	return ::_tcslen(szName);
}

CShortEventDesc::CShortEventDesc(IBonObject *pOwner)
	: CDescBase(pOwner)
{
	// Ȃ
}

CShortEventDesc::~CShortEventDesc(void)
{
	// Ȃ
}

const bool CShortEventDesc::ParseData(void)
{
	// TCŶ݃`FbN
	return (m_byDescLen >= 5U)? true : false;
}


/////////////////////////////////////////////////////////////////////////////
// [0x52] Stream Identifier LqqNX
/////////////////////////////////////////////////////////////////////////////

const BYTE CStreamIdDesc::GetComponentTag(void) const
{
	// R|[lg^OԂ
	return m_pDescData[0];

}

CStreamIdDesc::CStreamIdDesc(IBonObject *pOwner)
	: CDescBase(pOwner)
{
	// Ȃ
}

CStreamIdDesc::~CStreamIdDesc(void)
{
	// Ȃ
}

const bool CStreamIdDesc::ParseData(void)
{
	// TCŶ݃`FbN
	return (m_byDescLen == 1U)? true : false;
}
